Graphics3D 1024,768,32,2

AmbientLight 155,155,155


camera=CreateCamera()
CameraClsColor camera,100,100,100
CameraRange camera,1,5000
PositionEntity camera,-6,5,-29
grid=LoadMesh("mesh/grid.b3d")
PositionEntity grid,0,0,0

MoveMouse GraphicsWidth() / 2, GraphicsHeight() / 2 
mousespeed# = 0.5 
camerasmoothness# = 4.5

anim_type=3
anim_speed#=0.3
anim_speed2#=0.2
anim_seq=0

marine=LoadAnimMesh("mesh/marine/marine.b3d")
PositionEntity marine,0,0,0
ScaleEntity marine,.03,.03,.03
	
armor=FindChild(marine,"Box01")
body=FindChild(marine,"objhumanBody_0")
armor_cell1=FindChild(marine,"objBox02")
armor_cell2=FindChild(marine,"Mesh01")	
armor_cell3=FindChild(marine,"Object01")
armor_cell4=FindChild(marine,"GeoSphere01")			
			
;STATIC MESHES
d_wall=LoadMesh("mesh/d_wall/d_wall.b3d")
ScaleEntity d_wall,.03,.03,.03
PositionEntity d_wall,0,0,0




While Not KeyHit(1)

;MOTION CONTROL (AI)
If KeyDown(2) Then 
Animate armor,anim_type,anim_speed#
Animate body,anim_type,anim_speed#
Animate armor_cell1,anim_type,anim_speed#
Animate armor_cell2,anim_type,anim_speed#
Animate armor_cell3,anim_type,anim_speed#
Animate armor_cell4,anim_type,anim_speed#
EndIf



	
	; camera controll
	If KeyDown(17)    Then MoveEntity camera,  0.0,  0.0,  0.1
	If KeyDown(31)    Then MoveEntity camera,  0.0,  0.0, -0.1
	If KeyDown(30)    Then MoveEntity camera, -0.1,  0.0,  0.0
	If KeyDown(32)    Then MoveEntity camera,  0.1,  0.0,  0.0
	mxs# = CurveValue(MouseXSpeed() * mousespeed, mxs, camerasmoothness) 
	mys# = CurveValue(MouseYSpeed() * mousespeed, mys, camerasmoothness) 
	camxa# = camxa - mxs Mod 360 
	camya# = camya + mys 
	If camya < -89 Then camya = -89 
	If camya >  89 Then camya =  89 
	MoveMouse 800 / 2, 600 / 2
	RotateEntity camera, camya, camxa, 0

UpdateWorld
RenderWorld


Flip
Wend					
End

Function CurveValue#(newvalue#, oldvalue#, increments)
    If increments >  1 Then oldvalue# = oldvalue# - (oldvalue# - newvalue#) / increments 
    If increments <= 1 Then oldvalue# = newvalue#
    Return oldvalue# 
End Function